Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkAssemblyNode Class Reference

`#include <vtkAssemblyNode.h>`

Inheritance diagram for vtkAssemblyNode:

[legend]
Collaboration diagram for vtkAssemblyNode:

[legend]
List of all members.

## Detailed Description

represent a node in an assembly

Date:
  2002/12/26 18:24:21

Revision:
  1.10

vtkAssemblyNode represents a node in an assembly. It is used by vtkAssemblyPath to create hierarchical assemblies of props. The props can be either 2D or 3D.

An assembly node refers to a vtkProp, and possibly a vtkMatrix4x4. Nodes are used by vtkAssemblyPath to build fully evaluated path (matrices are concatenated through the path) that is used by picking and other operations involving assemblies.

Warning:
  The assembly node is guaranteed to contain a reference to an instance of vtkMatrix4x4 if the prop referred to by the node is of type vtkProp3D (or subclass). The matrix is evaluated through the assembly path, so the assembly node's matrix is a function of its location in the vtkAssemblyPath.

Warning:
  vtkAssemblyNode does not reference count its association with vtkProp. Therefore, do not create an assembly node, associate a prop with it, delete the prop, and then try to dereference the prop. The program will break! (Reason: vtkAssemblyPath (which uses vtkAssemblyNode) create self-referencing loops that destroy reference counting.)

See also:
  vtkAssemblyPath vtkProp vtkPicker vtkMatrix4x4

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (83%)
  - Martin, Ken (11%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkAssemblyNode.h)`
  - .`cxx` (`/Common/vtkAssemblyNode.cxx)`

Definition at line 68 of file vtkAssemblyNode.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual unsigned long | GetMTime ()
void | SetProp (vtkProp *prop)
virtual vtkProp * | GetProp ()
void | SetMatrix (vtkMatrix4x4 *matrix)
virtual vtkMatrix4x4 * | GetMatrix ()
## Static Public Methods
vtkAssemblyNode * | New ()
int | IsTypeOf (const char *type)
vtkAssemblyNode * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkAssemblyNode ()
| ~vtkAssemblyNode ()

## Member Typedef Documentation

typedef vtkObject vtkAssemblyNode::Superclass

| Reimplemented from vtkObject. Definition at line 74 of file vtkAssemblyNode.h.

## Constructor & Destructor Documentation

vtkAssemblyNode::vtkAssemblyNode | ( |  | ) | `[protected]`

vtkAssemblyNode::~vtkAssemblyNode | ( |  | ) | `[protected]`

## Member Function Documentation

vtkAssemblyNode* vtkAssemblyNode::New | ( |  | ) | `[static]`

| Create an assembly node. Reimplemented from vtkObject.

virtual const char* vtkAssemblyNode::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject.

int vtkAssemblyNode::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

virtual int vtkAssemblyNode::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

vtkAssemblyNode* vtkAssemblyNode::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject.

void vtkAssemblyNode::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject.

void vtkAssemblyNode::SetProp | ( | vtkProp * | prop | ) |

| Set/Get the prop that this assembly node refers to.

virtual vtkProp* vtkAssemblyNode::GetProp | ( |  | ) | `[virtual]`

| Set/Get the prop that this assembly node refers to.

void vtkAssemblyNode::SetMatrix | ( | vtkMatrix4x4 * | matrix | ) |

| Specify a transformation matrix associated with the prop. Note: if the prop is not a type of vtkProp3D, then the transformation matrix is ignored (and expected to be NULL). Also, internal to this object the matrix is copied because the matrix is used for computation by vtkAssemblyPath.

virtual vtkMatrix4x4* vtkAssemblyNode::GetMatrix | ( |  | ) | `[virtual]`

| Specify a transformation matrix associated with the prop. Note: if the prop is not a type of vtkProp3D, then the transformation matrix is ignored (and expected to be NULL). Also, internal to this object the matrix is copied because the matrix is used for computation by vtkAssemblyPath.

virtual unsigned long vtkAssemblyNode::GetMTime | ( |  | ) | `[virtual]`

| Override the standard GetMTime() to check for the modified times of the prop and matrix. Reimplemented from vtkObject.

The documentation for this class was generated from the following file:

- Common/vtkAssemblyNode.h